#pragma once

#include "DTVCapture/DTV_Base.h"
#include "Common/Lock.h"

#define WM_CHANNELWND_LISTUPDATE	(WM_APP+0x00)
#define WM_CHANNELWND_ENABLE		(WM_APP+0x01)

class CChannelWnd
{
public:
	CChannelWnd(CDTV_Base *pDtvObj);
	~CChannelWnd(void);

	BOOL IsWindowVisible() { return ::IsWindowVisible(m_hWnd); }
	BOOL ShowWindow(int iShowMode) { return ::ShowWindow(m_hWnd,iShowMode); }

	BOOL Create(HINSTANCE hInst,int iResource,HWND hParentWnd,BOOL bNoPosSize,int x,int y,int sx,int sy,int iShowMode);
	void Destroy(int *pX ,int *pY,int *pSX,int *pSY,BOOL *pbShow);
	int GetLastSelctChannel(){ return m_iLastSelChNo; }
	void SetEnable(BOOL bEnable);
	void UpdateChannelList(BOOL bEraseOnly,int iSetChNo);

protected:
	HWND m_hWnd;
	CDTV_Base *m_pDtvObj;
	LOCK_OBJ m_stLock;
	int m_iLastSelChNo;

	LRESULT ChannelDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);


protected:
	// WindowProc(Dummy)
	static LRESULT CALLBACK _ChannelDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
	{
	#pragma warning(disable: 4312)
		CChannelWnd* pThis=(CChannelWnd*)GetWindowLongPtr(hDlg,GWL_USERDATA);
	#pragma warning(default: 4312)
		if(message==WM_INITDIALOG)
		{
			{
				pThis=(CChannelWnd*)lParam;
	#pragma warning(disable: 4311)
				SetWindowLongPtr(hDlg,GWL_USERDATA,(LONG)pThis);
	#pragma warning(default: 4311)
			}
		}
		if(pThis)
		{
			return pThis->ChannelDlg(hDlg,message,wParam,lParam);
		} else {
			return FALSE;
		}
	}
};
